<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>JFLAP: Moore Machines</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070710;16053200">
	<META NAME="CHANGED" CONTENT="20070710;16064400">
	<!--@author Jinghui Lim-->
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<H1>Moore Machines</H1>
<H2>Contents</H2>
<P><A HREF="#definition">Definition</A><BR><A HREF="#differences">Differences
between a Moore Machine and an FA</A> 
</P>
<UL>
	<LI><P STYLE="margin-bottom: 0in"><A HREF="#finalState">No Final
	State</A> 
	</P>
	<LI><P STYLE="margin-bottom: 0in"><A HREF="#stateOutput">State
	Output</A> 
	</P>
	<LI><P STYLE="margin-bottom: 0in"><A HREF="#producingOutput">Producing
	Output from an Input String</A> 
	</P>
	<LI><P><A HREF="#nondeterminism">No Nondterminism</A> 
	</P>
</UL>
<P><A HREF="#outputConvention">Output Convention</A><BR><A HREF="mooreExamples.html">Proceed
to Moore Machine Examples</A> 
</P>
<H2><A NAME="definition"></A>Definition</H2>
<P>JFLAP defines a Moore machine <I>M</I> as the sextuple <I>M</I> =
(<I>Q</I>, Σ<!--capital sigma-->, Γ<!--capital gamma-->, δ<!--small delta-->,
ω<!--small omega-->, <I>q<SUB>s</SUB></I>) where 
</P>
<P><I>Q</I> is a finite set of states {<I>q<SUB>i</SUB></I> | <I>i</I>
is a nonnegative integer} <BR>Σ<!--capital sigma--> is the finite
input alphabet <BR>Γ<!--capital gamma--> is the finite output
alphabet <BR>δ<!--small delta--> is the transition function, δ<!--small delta-->
: <I>Q</I> &times;<!--times--> Σ<!--capital --><!--sigma--> →<!--right arrow-->
<I>Q</I> <BR>ω<!--small omega--> denotes the output function, ω<!--small --><!--omega-->
: <I>Q</I> →<!--right arrow--> Γ<!--capital --><!--gamma--> <BR><I>q<SUB>s</SUB></I>
(is a member of<!--&#8712;--><!--element of--> <I>Q</I>) is the
initial state 
</P>
<P>Moore machines are different than <A HREF="mealyMachines.html">Mealy
machines</A> in the output function, ω<!--small omega-->. In a Moore
machine, output is produced by its states, while in a Mealy machine,
output is produced by its transitions. 
</P>
<P>To start a new Moore machine, select the <B>Moore Machine</B>
option from the main menu. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreSelection.png" NAME="Graphic1" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Starting a new Moore machine 
</P>
<H2><A NAME="differences"></A>Differences between a Moore Machine and
an FA</H2>
<P>A Moore machine is very similar to a <A HREF="../fa/fa.html">Finite
Automaton</A> (FA), with a few key differences: 
</P>
<UL>
	<LI><P STYLE="margin-bottom: 0in">It has <A HREF="#finalState">no
	final states</A>. 
	</P>
	<LI><P STYLE="margin-bottom: 0in">Its <A HREF="#stateOutput">states
	produce output</A>. 
	</P>
	<LI><P STYLE="margin-bottom: 0in">It does not accept or reject
	input, instead, it <A HREF="#producingOutput">generates output from
	input</A>. 
	</P>
	<LI><P>Lastly, Moore machines <A HREF="#nondeterminism">cannot have
	nondeterministic states</A>. 
	</P>
</UL>
<P>Let's go through these points. 
</P>
<H3><A NAME="finalState"></A>No Final State</H3>
<P>In an FA, when you have the Attribute Editor tool selected (you
may do so by clicking the 
<IMG SRC="images/arrow.gif" NAME="Graphic2" ALIGN=BOTTOM BORDER=0>
button), right-clicking on a state will produce a pop-up menu that
allows you to, among other things, set it to be a final state. In a
Moore machine, that option is not available. 
</P>
<CENTER>
	<TABLE CELLPADDING=2 CELLSPACING=2>
		<TR>
			<TD>
				<P ALIGN=CENTER><IMG SRC="images/FSAStateMenu.png" NAME="Graphic3" ALIGN=BOTTOM BORDER=0></P>
			</TD>
			<TD>
				<P ALIGN=CENTER><IMG SRC="images/mealyStateMenu.png" NAME="Graphic4" ALIGN=BOTTOM BORDER=0></P>
			</TD>
		</TR>
		<TR>
			<TD>
				<P ALIGN=CENTER>An FA state menu</P>
			</TD>
			<TD>
				<P ALIGN=CENTER>A Moore machine state menu</P>
			</TD>
		</TR>
	</TABLE>
</CENTER>
<P>A Moore machine does not have final states because it does not
accept or reject input. Instead, each state produces output, which
will be described below. 
</P>
<H3><A NAME="stateOutput"></A>State Output</H3>
<P>A Moore machine produces output when it is at a state. 
</P>
<P>Creating a Moore machine is the same as creating an FA with the
exception of creating its states. In a Moore machine, each state
produces output. When you are creating a state, a popup dialog box
appears that prompts you for the output of the state. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreStateCreate.png" NAME="Graphic5" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Entering the state output 
</P>
<P>Type the state output in the dialog box and hit click <B>OK</B>.
(If you click <B>Cancel</B>, the state will still be created, it will
just have an empty string as its output.) When the state is created,
its output will be show in its top right hand corner: 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreStateDone.jpg" NAME="Graphic6" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>State created 
</P>
<P>Thus, when the machine is in state <I>q</I><SUB>0</SUB>, it will
produce an output of &quot;1&quot;. To change the state output, click
on the state using the Arrow tool 
<IMG SRC="images/arrow.gif" NAME="Graphic7" ALIGN=BOTTOM BORDER=0>,
and enter the new output in the dialog box. 
</P>
<P>With each state producing output, the Moore machine can produce
output from an input string. 
</P>
<H3><A NAME="producingOutput"></A>Producing Output from an Input
String</H3>
<P>Instead of accepting or rejecting input, a Moore machine produces
output from an input string. 
</P>
<P>Let's look at this simple Moore machine (which is provided in
<A HREF="files/mooreNOT.jff">mooreNOT.jff</A>): 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreNOT.png" NAME="Graphic8" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>A simple Moore machine 
</P>
<P>When we select the menu option <B>Input : Step...</B> and enter
your input, we get a display similar to that of an FA, except with
another piece of tape below the input tape. This displays the output
of the machine at the current step. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreOutputDisplay.jpg" NAME="Graphic9" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>The output display 
</P>
<P>At each step. The output tape updates itself to display the total
output that has been produced so far: 
</P>
<CENTER>
	<TABLE CELLPADDING=2 CELLSPACING=2>
		<TR>
			<TD>
				<P>Initial:</P>
			</TD>
			<TD>
				<P>Step 1:</P>
			</TD>
			<TD>
				<P>Step 2:</P>
			</TD>
			<TD>
				<P><B>. . . </B>
				</P>
			</TD>
			<TD>
				<P>Final:</P>
			</TD>
		</TR>
		<TR>
			<TD>
				<P><IMG SRC="images/mealyStep0.png" NAME="Graphic10" ALIGN=BOTTOM BORDER=0></P>
			</TD>
			<TD>
				<P><IMG SRC="images/mooreStep1.png" NAME="Graphic11" ALIGN=BOTTOM BORDER=0></P>
			</TD>
			<TD>
				<P><IMG SRC="images/mooreStep2.png" NAME="Graphic12" ALIGN=BOTTOM BORDER=0></P>
			</TD>
			<TD>
				<P><B>. . . </B>
				</P>
			</TD>
			<TD>
				<P><IMG SRC="images/mooreStep5.png" NAME="Graphic13" ALIGN=BOTTOM BORDER=0></P>
			</TD>
		</TR>
	</TABLE>
</CENTER>
<P>The menu option <B>Input : Fast Run...</B> works similarly, with
the output being displayed in a tape under the input tape: 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreFastRun.png" NAME="Graphic14" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Fast run output display 
</P>
<P>Similarly, when we select <B>Input : Multiple Run</B>, output is
displayed in the <B>Result</B> column. 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreMultipleRun.png" NAME="Graphic15" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Multiple run output display 
</P>
<H3><A NAME="nondeterminism"></A>No Nondeterminism</H3>
<P>As Moore machines map an input to a unique output, nondeterminism
cannot exist in a Moore machine. Although we still will be able to
build a Moore machine that has nondeterminism, we will not be able to
run input on it. 
</P>
<P>For instance, let's modify our machine slightly to make: 
</P>
<P ALIGN=CENTER><IMG SRC="images/mooreNondeterminism.jpg" NAME="Graphic16" ALIGN=BOTTOM BORDER=0>
</P>
<P ALIGN=CENTER>Moore machine with nondeterminism 
</P>
<P>We we try to run it on an input, with <B>Input : Step...</B>,
<B>Input : Fast Run...</B>, or <B>Input : Multiple Run...</B>, we
will get an error message asking us to remove the nondeterministic
states: 
</P>
<P ALIGN=CENTER><IMG SRC="images/nondeterminismErrorMessage.png" NAME="Graphic17" ALIGN=BOTTOM BORDER=0>
</P>
<P>Select <B>Test : Highlight Nondeterminism</B> to view the
nondterministic states. Remove the nondeterminism in order to be able
to run input on the Moore machine. 
</P>
<H2><A NAME="outputConvention"></A>Output Convention</H2>
<P>In JFLAP, we adopt the output convention that the machine produces
the output associated with the start state when it is turned on. (The
alternate view is that the machine does not produce output until the
first symbol of input is read.) If we wish to use the alternate view
for a machine, we may just add a start state with the empty string as
its output, like the machine described above. 
</P>
<P><B>This concludes our brief tutorial on Moore machines. Thanks for
listening!</B> 
</P>
<P>View <A HREF="mooreExamples.html">Moore machine examples</A>.<BR>View
<A HREF="mealyMachines.html">Mealy machines</A>. 
</P>
</BODY>
</HTML>
